#include "..\ve\sconti.h"

class TCondizione_vendita : public TObject
{
  TString80 _sconto;
  TString16 _codiva;
  bool _ivarid;
  real _prezzo;
  real _provv;
  real _molt_sconto;
  TCliFor * _clifo;
  TLocalisamfile _condv;
  TLocalisamfile _rcondv;
  TLocalisamfile _sconti;
  TLocalisamfile * _anamag; // file passato e posizionato esternamente
  TLocalisamfile * _umart;	// file passato e posizionato esternamente
  TConfig * _config_ditta;
  bool _load_mask;

  bool cerca(int tiporicerca,const char * cod, const real & qta);    
  
protected:

  TRectype & testa() const { return  (_condv.curr()); }
  TRectype & riga() const { return  (_rcondv.curr()); }
  TLocalisamfile & anamag() const { CHECK(_anamag, "Anagrafica di magazzino non inizializzata") ; return *_anamag; }
  TLocalisamfile & umart() const { CHECK(_umart, "Anagrafica di unita' di misura magazzino non inizializzata") ; return *_umart; }
  
public:
  real get_prezzo() const { return _prezzo; }
  
  TConfig &config_ditta() const { return *_config_ditta; }
  void set_config( TConfig & ditta){ _config_ditta = &ditta; }
  void set_anamag(TLocalisamfile & anamag) { _anamag = &anamag; }
  void set_umart(TLocalisamfile & umart) { _umart = &umart; }

  bool gestum() const { return _condv.get_bool("GESTUM"); }
  
	// prepara la ricerca 
	void put_condv(const char *tipocv,const char * codcv,const char *catven,const char *tipocf,const char *codcf);
	void put_listino(const char * codlist,const char *catven);
	void put_contratto(const char * codcontr,const char *tipocf,const char *codcf);
	void put_offerta(const char * codoff);
	// ricerca il codice 
	bool ricerca(const char * cod,const real & qta=0) ;

  TCondizione_vendita(TConfig * _ditta = NULL, TLocalisamfile * anamag = NULL, TLocalisamfile * umart = NULL);    
  ~TCondizione_vendita() {}
};

